--- src/core/nginx.c.orig	Tue Mar 24 13:55:59 2009
+++ src/core/nginx.c	Tue Mar 24 14:07:49 2009
@@ -182,6 +182,7 @@
 
 ngx_uint_t  ngx_max_module;
 
+static ngx_uint_t  ngx_show_help;
 static ngx_uint_t  ngx_show_version;
 static ngx_uint_t  ngx_show_configure;
 
@@ -241,6 +242,25 @@
         return 1;
     }
 
+    if (ngx_show_help) {
+
+        p = "Usage: nginx [-h] [-v] [-V]"
+            " [-t] [-c filename] [-g param] [-d basedir]\n\n"
+            "Options: \n"
+            "\t-h           : list available command line options (this page)\n"
+            "\t-v           : show version then exit\n"
+            "\t-V           : show version and configure options then exit\n"
+            "\t-c filename  : set conf file (default: " NGX_CONF_PATH ")\n"
+            "\t-g param     : set conf directives out of conf file\n"
+            "\n";
+        n = strlen(p);
+
+        if (ngx_write_fd(ngx_stderr_fileno, p, n) != n) {
+            return 1;
+        }
+        /* Don't return here as ngx_show_version will return for us */
+    }
+
     if (ngx_show_version) {
 
         p = "nginx version: " NGINX_VER CRLF;
@@ -628,6 +648,11 @@
         }
 
         switch (argv[i][1]) {
+
+        case 'h':
+            ngx_show_help = 1;
+            ngx_show_version = 1;
+            break;
 
         case 'v':
             ngx_show_version = 1;